/*
* Copyright (c) 2007, 2010, Oracle and/or its affiliates. All rights reserved.
* ORACLE PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
*/

/*
 * $Id: LocalTxMessageWork2.java 67292 2012-08-23 20:45:07Z phendley $
 */

package com.sun.ts.tests.common.connector.whitebox;

import java.lang.reflect.Method;
import javax.resource.spi.endpoint.MessageEndpoint;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.UnavailableException;
import javax.resource.spi.work.Work;
import com.sun.ts.tests.common.connector.util.TSMessageListenerInterface;
import com.sun.ts.tests.common.connector.util.ConnectorStatus;
import com.sun.ts.tests.common.connector.util.AppException;


public class LocalTxMessageWork2 implements Work {

    private String name;
    private boolean stop = false;
    private MessageEndpointFactory factory;
    private LocalTxMessageXAResource msgxa = new LocalTxMessageXAResource("LocalTxMessageXAResource2");
    
    public LocalTxMessageWork2(String name, MessageEndpointFactory factory) {
        this.factory = factory;
        this.name = name;
        System.out.println("LocalTxMessageWork2.constructor");
    }

    public void run() {

        while (!stop) {
            try {
                
                //creating xaep to check if the message delivery is transacted.
                MessageEndpoint xaep = factory.createEndpoint(msgxa);
                MessageEndpoint xaep1 = factory.createEndpoint(msgxa);
                MessageEndpoint xaep2 = factory.createEndpoint(msgxa);

                Method onMessagexa = getOnMessageMethod();
                ((TSMessageListenerInterface) xaep).onMessage("LocalTx MDB2 Transacted Message1");
                ((TSMessageListenerInterface) xaep1).onMessage("LocalTx MDB2 Transacted Message2");
                ((TSMessageListenerInterface) xaep2).onMessage("LocalTx MDB2 Transacted Message3");

                ConnectorStatus.getConnectorStatus().logState("LocalTx MDB2 Transacted Message1");
                ConnectorStatus.getConnectorStatus().logState("LocalTx MDB2 Transacted Message2");
                ConnectorStatus.getConnectorStatus().logState("LocalTx MDB2 Transacted Message3");


                break;
            } catch (AppException ex) {
                 ex.printStackTrace(); 
            }
            catch (UnavailableException ex) {
                try 
                {
                    Thread.currentThread().sleep(3000);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
        
    }

    public Method getOnMessageMethod() {

        Method onMessageMethod = null;
        try {
            Class msgListenerClass = TSMessageListenerInterface.class;
            Class[] paramTypes = { java.lang.String.class };
            onMessageMethod =
                msgListenerClass.getMethod("onMessage", paramTypes);

        } catch (NoSuchMethodException ex) {
            ex.printStackTrace();
        }
        return onMessageMethod;
    }
 
    @Override
    public void release() {}

    public void stop() {
        this.stop = true;
    }

    public String toString() {
       return name;
    }

}
